/***************************************************************************
                          s_multi_loop.h  -  description
                             -------------------
    begin                : Mon Apr 15 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef S_MULTI_LOOP_H
#define S_MULTI_LOOP_H

#include "structs.h"

/*
struct multi_details
{
    short int num_branches;
    pair branches[MAX_BRANCHES];                     // a vector of branches
    multi_details ()
    {
        num_branches = 0;
    }
};
*/


class s_multi_loop
{
    public:

        friend class s_energy_matrix;

        s_multi_loop (int *seq, int length);
        // The constructor

        ~s_multi_loop ();
        // The destructor

        void set_energy_matrix (s_energy_matrix *V) { this->V = V; }
        // Set local energy matrix to V

        int compute_energy (int i, int j);
        // compute the MFE of a multi-loop closed at (i,j)
        int compute_energy_restricted (int i, int j, str_features *fres);
        
        void compute_energy_WM (int j);
        // compute de MFE of a partial multi-loop closed at (i,j)
        void compute_energy_WM_restricted (int j, str_features *fres);
        
        int get_energy_WM (int i, int j) { int ij = index[i]+j-i; return WM[ij]; }
        // returns the previously computed free energy of WM(i,j)   


    private:
        int *sequence;                 // the entire sequence for which we compute the energy
        int seqlen;                     // sequence length

        s_energy_matrix *V;               // a pointer to the free energy matrix V

        int *index;
        int *WM;      // WM - 2D array

};


#endif

